{$APPTYPE CONSOLE}
program Demo1;
uses Objects, Windows, Ext_Crt, Drivers, Views;
type
  TConsoleLineBuf = array[0..(1024*32) - 1] of TCharInfo;
  PVideoCell = ^TVideoCell;
  TVideoCell = record
    fChar:char;
    fAttr:byte;
  end;
  TVideoBuf = array[0..3999] of TVideoCell;
  PVideoBuf = ^TVideoBuf;
type
  TConsole = object(TObject)
    procedure WriteBuf(X, Y, W, H: Integer; var Buf);
  end;

var
  LineBuf:TConsoleLineBuf;
  { TConsole }
procedure TConsole.WriteBuf(X, Y, W, H: Integer; var Buf);
var
  ABuf:TVideoBuf absolute Buf;
  BufSize,
  BufCoord    : COORD;
  WriteRegion : SMALL_RECT;
  LineCounter,
  ColCounter,
  BufCounter:integer;
begin
  BufSize.X:=W;
  BufSize.Y:=H;
  BufCoord.X := 0;
  BufCoord.Y := 0;
  WriteRegion.Top :=X;
  WriteRegion.Left :=Y;
  WriteRegion.Right :=X+W;
  WriteRegion.Bottom :=Y+H;
  BufCounter := 0;
  for LineCounter := Y to H+Y-1 do
    begin
       for ColCounter := X to W+X-1 do
         begin
           LineBuf[BufCounter].AsciiChar := ABuf[BufCounter].fChar;
           LineBuf[BufCounter].Attributes := ABuf[BufCounter].fAttr;
           Inc(BufCounter);
         end; { for }
    end; { for }
  WriteConsoleOutput(hStdout, @LineBuf, BufSize, BufCoord, WriteRegion);
end;

var
  i:integer;
  Console:TConsole;
  B:TDrawBuffer;
  S:ShortString;
begin
  SetTextAttr(7);
  writeln('This is demo program');
  SaveScreen;
  ClrScr;
  S:='This demo...123';
  MoveStr(B, S,10);
  Console.WriteBuf(10,10,Length(S)-1,1,B);
  readln;
  RestoreScreen;
  readln;
end.

