{          ᮧ                   }
{   ᥢ筮 ।                  }
{     (䮭 ᮢ)                      }
{          Turbo Vision                       }
{     ࠭ Turbo Pascal              }
{          Borland Pascal                     }
{  ॠ쭮 ० ࠡ  8086 }

{ ஢:                              }
{ CPU : 80286, 80386D, 80486D                }
{ RAM : 1 MB, 4 MB                             }
{  OS : DOS 5.0                                }
{  TV : Turbo Vision v 2.0                     }
{ PAS : Borland Pascal v7.0                    }
{ ࠡ⠭:                                 }
{  ⠭᫠ 쥢                     }
{ ᪢ / 1994                                }
{$F+}
unit MultTask;
Interface
uses  Objects, App;

 { ' - ᭮ ஥  /  }
type
   PTask = ^TTask;
   TTask = object(TObject)
      NTacts,          { ⥪饥 祭 稪 ⨪     /   }
      Ticks:integer;  {ਮ  ( 㬮砭 = 5 )/ }
      Freeze:boolean; {True, ᫨  ஦          /   }
      Stack,          { 㪠⥫  ⥪              /   }
      TaskSSSP : pointer; { ⥪饥 ﭨ          /   }
      constructor Init; { 樠  }
      destructor Done; virtual; { 襭  }
      procedure Executer; virtual; { ᯮ塞 ⮤  ४뢠: ᥣ }
      procedure SetPriority(Prior : integer);{ ⠭  ਮ   }
      procedure LockTV; { 쭮 ᯮ  1 ஢ TV }
      procedure UnLockTV; { ࠧ஢ TV }
   end;

{ ꥪ - ᭮ ஥ 筮 । }
type
   PMultyTaskApp = ^TMultyTaskApp;
   TMultyTaskApp = object(TApplication)
      Tasks : PCollection;         {  ᮢ }
      constructor Init;            { 樠 । }
      procedure Idle; virtual;     { ४⥫ ᮢ }
      destructor Done; virtual;    { 室  । }
      procedure NewTask(ATask :PTask); { ஦   }
      procedure PreTaskSw; virtual; {뢠  ஦ ࢮ }
      procedure PostTaskSw; virtual; { 뢠  砭 ᫥  }
      procedure FreezeTask(ATask : PTask); { ஧  }
      procedure UnFreezeTask(ATask:PTask); { ࠧ ஧   }
      procedure FreezeAll;                   {஧   ⥬}
      procedure UnFreezeAll;                 {ࠧ஧   ⥬}
      procedure TermTask(ATask:PTask);       {㭨⮦ }
      procedure TermALL;                     { 㭨⮦   }
      procedure TaskError; virtual; { ४뢠 짮⥫  ॠ樨  訡 }
   end;

const
  TaskStackSize:word = 32*1024; { ࠧ ⥪ 䮭  }
  TVAvailable:boolean = true;   { ਧ 쭮 믮  }
  MultyTaskApp : PMultyTaskApp = nil; { 㪠⥫  PMultyTaskApp }

implementation
uses Drivers, DOS; { ᯮ㥬 㫨 }
var
  Old1C : pointer; { ࠭ ண  O1Ch }
  SaveExitProc : pointer; { ࠭ ன 窨 室 }
                          { ணࠬ }

type
   StackRecord = record { ⨯ - ⥪  }
      Size:word; { ࠧ ⥪ }
      Address:Pointer ; { ॠ  㪠⥫  墠 }
   end;

{ 譨 ணࠬ }
{$L SWITCH.OBJ}
function InitTaskStack(AStack,ATaskAddr,This:pointer):pointer;far; external;
{ ନ஢ ⥪  }
function GoToTask(var TaskSP : pointer):boolean; far; external;
{ ४祭  }
procedure ClockInt(BP : Word); far; external;
{ ࠡ稪 O1Ch 뢠 no ⠩ )

{ ᠭ  TTask }

constructor TTask.Init; { 墠  樠 ⥪   }
var
  StackRecPtr:^StackRecord absolute Stack;
  Pots:word absolute Stack;
  PTemp:Pointer;
  ActualSize:Longint;
  TaskAddr:pointer;
begin
  inherited Init; { ࠧ  ⮬   ⥪ }
  ActualSize:=Longint(TaskStackSize)+6;
  Stack:=nil;
  Ticks:=5;       { 砫쭮 祭 ਮ }
   {  墠   ? }
  if (MaxAvail >= ActualSize) and (ActualSize <= 65521 ) then
  begin
    GetMem(Stack, Word(ActualSize));
    PTemp := Stack;               {࠭ ᠬ}
    Inc(POts, TaskStackSize);     {ᤢ 㪠⥫  設 ⥪ }
    asm                             {  㠫쭮  @Executer}
       LES    BX,Self
       MOV    BX,ES:[BX]
       MOV    AX,WORD PTR [BX + 0Ch] { ᬥ饭 }
       MOV    BX,WORD PTR [BX + 0Ch + 2] { ᥣ }
       MOV    WORD PTR TaskAddr,AX
       MOV    WORD PTR TaskAddr+2,BX
    end;
    TaskSSSP := InitTaskStack(Stack, TaskAddr, @Self);
    with StackRecPtr^ do
    begin                  {  ࠧ  砫 ⥪ }
      Address:=PTemp;
      Size:= Word(ActualSize);
    end;
  end;
end;

procedure TTask.Executer;
begin
{  ᯮ  짮⥫.}
{  ⮤ ४뢠 ᥣ         }
end;

procedure TTask.SetPriority(Prior:integer);
 {⠭  祭 ਮ .
 襬 祭 Prior ᮮ⢥
 訩 ਮ 
 (砫쭮 祭 - 5) }
begin
  Ticks:=Prior;
end;

procedure TTask.LockTV;
{   믮 ॥ࠡ 楤 Turbo Vision }
{   Turbo Pascal (Borland Pascal),                       }
{  ⨯ New, Dispose, Intr   䮭 .             }
{   室  .                             }
{  ᯮ ⮫쪮 䮭묨 ᠬ.               }
begin
  TVAvailable:=False;
end;

procedure TTask.UnLockTV;
{  ᭮  ᫥ ᯮ }
{ ॥ࠡ 楤.                    }
{ ᯮ ᫥ 맮 LockTV               }
begin
 TVAvailable:=true;
end;

destructor TTask.Done;
{ 㤠 ⥪   㤠  }
var
  StackRecPtr:^StackRecord absolute Stack;
begin
 if Stack<>nil then
 with StackRecPtr^ do
      FreeMem(Address, Size); { ᢮  - ⥪ ) }
 inherited Done;
end;

{  ᠭ  TMultyTaskApp }

constructor TMultyTaskApp.Init;   { 樠 । }
begin
  inherited Init;                    { 樠 TApplication }
  MultyTaskApp:=@Self;               { ⠭ 㪠⥫  TMultyTaskApp }
  Tasks:=New(PCollection, Init(5,5));{ 樠 樨  }
end;

procedure TMultyTaskApp.Idle;
{ ************ ४⥫  ***************** }
{ ४祭 ந室  ᢮  ᯮ }
{ ᭮  ६. }
{ ࠭ 쭮 믮 }
{ ॥ࠡ 楤 ᭮ ᮬ }
{  ⥫ ⢨  ஭ 짮⥫ }
var
  T:PTask; { 㪠⥫  ⥪ ४砥  }
const
  CurTask:Integer=0;  { ⥪饩   樨  }
  OldCount:Integer=0; {  ।饩   樨  }

function NextTask : pointer;
var
  T:PTask;
  NT:integer;
begin
  if CurTask >= OldCount then CurTask:=0; {᫨ ⥪  }
                                    { 室  ࠭ 樨  }
                                    {  ⠭    }
  NT := CurTask; {   ⥪饩  }
  repeat
    T:=Tasks^.At(CurTask);     {  ⥪饩  }
    with T^ do
    begin
       if not Freeze then      { ᫨   ஦ }
       begin
         inc(NTacts);          { ᫥騩 ⨪ ६  }
         if NTacts = Ticks then
         begin                 { ᫨ ⨣ 祭 ਮ }
           inc(CurTask);       { ६⨬  ᫥  }
           NTacts:=0;          {  ᫥  ⨪ 맮 }
           NextTask:=T;        { ୥ 㪠⥫   }
           exit;
         end;
       end;
    end;
    Inc(CurTask);              {த ᪠஢  樨 }
    if CurTask >= OldCount then CurTask := 0;
  until CurTask = NT;  {᪠㥬  ᮢ  室 ஬ }
  NextTask:=nil;       { ᫨      諮 ६ }
                       {  ४祭,  ୥ NIL }
end;
begin
  inherited Idle; { ⮤ Idle ꥪ TApplication }
  if (OldCount=0) and (Tasks^.Count<>0) then PreTaskSw else
  if (OldCount<>0) and (Tasks^.Count=0) then PostTaskSw;
     { ஢ઠ ᫮ 맮 PreTaskSw  PostTaskSw }
  OldCount:=Tasks^.Count;     {࠭ ⢠  }
  if OldCount<>0 then         {᫨     }
  begin
    T:=NextTask;              {  ।  }
    if T<>nil then            { ᫨  諠,  }
       if GoToTask(T^.TaskSSSP) { ४祭   }
          then Tasks^.AtFree(Tasks^.IndexOf(T));  { ᫨  訫 - }
                          { ஥   㤠  樨 }
  end;
end;

procedure TMultyTaskApp.NewTask(ATask:PTask); { 祭     }
begin
  if (ATask=nil) or {᫨  = nil}
     (ATask^. Stack = nil) then TaskError {    ⥪,  訡 }
  else Tasks^.Insert(ATask); {  砥   }
end;

procedure TMultyTaskApp.PreTaskSw;
{  뢠  ஦ ࢮ . }
{ ४뢠 짮⥫  ⠭ ࠬ஢ }
{ ᢮ ⥬, ਬ ࠧ襭/饭 }
{   EnableCommands([])/DisabieCommands[]) }
{    ⢨ }
begin
end;

procedure TMultyTaskApp.PostTaskSw;
{ 뢠  砭 ᫥ . }
{ ४뢠 짮⥫, 筮 PreTaskSw }
begin
end;

procedure TMultyTaskApp.FreezeTask(ATask:PTask);
{ 뢠  ६ ࠦ  ()}
{ 饭 ४祭    }
begin
  if ATask<>nil then ATask^.Freeze:=true;
end;

procedure TMultyTaskApp.UnFreezeTask(ATask:PTask);
 { ࠧࠦ  () }
begin
  if ATask<>nil then ATask^.Freeze:=false;
end;

procedure TMultyTaskApp.TermTask(ATask:PTask);
{ 㤠 (ନ஢)   }
{ ᪫祭  樨  }
begin
  with Tasks^ do AtFree(IndexOf(ATask));
end;

procedure TMultyTaskApp.FreezeAll;
 { ࠦ   }
  procedure Freezeltem(Item:PTask); far;
  begin
    Item^.Freeze:=true;
  end;
begin
  Tasks^.ForEach(@Freezeltem);
end;

procedure TMultyTaskApp.UnFreezeAll;
 { ࠧࠦ   }
  procedure UnFreezeItem(Item:PTask );far;
  begin
    Item^.Freeze:=false;
  end;
begin
  Tasks^.ForEach(@UnFreezeItem);
end;

procedure TMultyTaskApp.TermAll;
 { 㤠 (ନ஢)   }
begin
  Tasks^.FreeAll;
end;

procedure TMultyTaskApp.TaskError;
{ 㠫 ⮤ 뢠  訡 祭 }
{    ⥬. }
{ ४뢠 짮⥫  ॠ樨  訡 }
begin
end;

destructor TMultyTaskApp.Done;
{ 襭 筮 । }
begin
  Dispose(Tasks, Done); { 㤠塞   }
  inherited Done;      { 뢠 TApplication.Done }
end;

procedure MTExit;
begin
 ExitProc := SaveExitProc; { । 室 ୥  室 }
 SetIntVec($08, Old1C); {  ஥ 祭  뢠 }
end;

begin
  SaveExitProc:=ExitProc; { ࠭  室  ணࠬ }
  ExitProc:=@MTExit; {  ⠭ ᢮ }
  GetIntVec($08, Old1C); { ࠭  뢠  ⠩ }
  SetIntVec($08, @ClockInt); {  ⠭ ᢮ }
end.
